<template>

  <div style="  min-height: 100vh;
    display: flex;
    justify-content: center;
    align-items: center;
    text-align: center;" v-loading.fullscreen.lock="loading">
    <el-card class="box-card" >
      <div slot="header" class="clearfix">
        <h3 style="line-height: 36px;">{{title}}</h3>
      </div>

      <el-form  style="width: 350px">
        <el-form-item v-if="status">
          <el-input placeholder="Masukan nomot hp anda" v-model="input.phone" @keyup.enter.native="doLogin">
            <el-select v-model="input.select" slot="prepend" placeholder="Country">
              <el-option label="+62" value="62"></el-option>
            </el-select>
          </el-input>
        </el-form-item>
        <el-form-item v-if="!status" >
          <el-input placeholder="Masukan email anda" v-model="input.email" @keyup.enter.native="doLogin">
            <el-select v-model="input.select" slot="prepend" placeholder="Email">
              <el-option label="email" value="+62"></el-option>
            </el-select>
          </el-input>
        </el-form-item>
      </el-form>

      <div class="bottom clearfix">
        <el-button style="width: 100%;" type="primary" @click="doLogin">Masuk</el-button>
        <el-button type="text" @click="loginEmail"> {{text}}</el-button>
      </div>
    </el-card>
  </div>
</template>

<script>
  import validator from 'email-validator'


  export default{
    middleware:'auth',
    data(){
      return {
        loading :false,
        status:true,
        state:"randomstreingaeaeadfd",
        title:'Masuk LazyRest',
        text:"gunakan email",
        input:{
          country:'',
          select:'+62',
          phone:'',
          email:''
        }
      }
    },
    methods:{
        myswitch(){
            this.status = !this.status;
            this.text = this.status ? "gunakan email":"gunakan no hp";
        },
        phoneValidate(arg){
           return isNaN(arg)
        },
      async handleLogin(response){
        if (response.status === "PARTIALLY_AUTHENTICATED") {
           this.loading = true;
           let user = await this.$store.dispatch('checkUser',{code:response.code});

           try{
               let body  = {
                 fb_token:user.id,
                 email:user.email ? user.email.address : undefined,
                 phone_number:user.phone ? user.phone.number : undefined
               };
               await this.$store.dispatch('login',body);
               this.loading = false;
             window.location.reload()
           }catch (err){
             this.$message({
               message: err.message,
               showClose: true,
               type: 'warning'
             });
           }
        }
        else if (response.status === "NOT_AUTHENTICATED") {
          this.$message({
            message: 'Gagal masuk!',
            showClose: true,
            type: 'warning'
          });
        }
        else if (response.status === "BAD_PARAMS") {
          this.$message({
            message: 'Gagal masuk!',
            showClose: true,
            type: 'warning'
          });
        }
      },
      loginEmail(){
        AccountKit.login(
          "EMAIL",
          {},
          this.handleLogin
        );
      },
      doLogin(){
        try{
          if(this.status){
            if(!this.phoneValidate(this.input.phone)&&  this.input.phone){
                //console.log(this.input.select);
              AccountKit.login(
                "PHONE",
                {countryCode: this.input.select, phoneNumber: this.input.phone},
                this.handleLogin
              );
            } else{
              this.$message({
                message: 'Masukan nomor hp anda!',
                showClose: true,
                type: 'warning'
              });
            }
          }else{
            if(validator.validate(this.input.email) && this.input.email){
              AccountKit.login(
                "EMAIL",
                {emailAddress: this.input.email},
                this.handleLogin
              );
            }else{
              this.$message({
                message: 'Masukan alamat email anda!',
                showClose: true,
                type: 'warning'
              });
            }
          }
        }catch(err){
          return this.$message({
            message: err.message,
            showClose: true,
            type: 'error'
          });
        }
      }
    },
    mounted(){
        try{

          AccountKit.init(
            {
              appId:1972499469673698,
              state:this.state,
              version:"v1.0"
            }
          );
        }catch (err){

          return this.$message({
            message: err.message,
            showClose: true,
            type: 'error'
          });
        }
    },
    head(){
      return {
        title:'Masuk | LazyREST',
        meta: [
          { hid: 'description', name: 'description', content: 'LazyRest api for testing/prototyping/learning' }
        ]
      }
    }
  }
</script>


<style>
  .el-select .el-input {
    width: 80px;
  }
</style>
